int Mouse_OldCol=-1;

void Display_Mouse(int PaintOrUnpaint) //0=paint, 1==unpaint
{
	int y, offset;

	if( Mouse_Module == 0 ) return;

	if( Mouse_Y>0 )
		y=Mouse_Y-1;
	else
		y=55;

	offset = 0xB8000 + y*160+Mouse_X*2+1;

	if( PaintOrUnpaint==1 )
	{
		if( Mouse_OldCol==-1 )
		{
			term_puts( SCR_CRASH, "Mouse_Unpaint -1" );
			return;
		}

		term_puts( SCR_CRASH, "Mouse_Unpaint x=" );
		term_hexprints( SCR_CRASH, Mouse_X );
		term_puts( SCR_CRASH, " y=" );
		term_hexprints( SCR_CRASH, Mouse_Y );
		term_puts( SCR_CRASH, " y2=" );
		term_hexprints( SCR_CRASH, y );
		term_puts( SCR_CRASH, "\r\n" );


		pokeb( 0x18, offset, Mouse_OldCol );
	} else
	{
		term_puts( SCR_CRASH, "Mouse_Paint x=" );
		term_hexprints( SCR_CRASH, Mouse_X );
		term_puts( SCR_CRASH, " y=" );
		term_hexprints( SCR_CRASH, Mouse_Y );
		term_puts( SCR_CRASH, " y2=" );
		term_hexprints( SCR_CRASH, y );
		term_puts( SCR_CRASH, "\r\n" );

		Mouse_OldCol=peekb( 0x18, offset );
		pokeb( 0x18,  offset, (15-(0x0F & Mouse_OldCol))+16*6 ); // invert foreground-color, set background
			// + 16*5
	}
}

int UpdateMouseButtons()
{
	short buf;

	if( Mouse_Module == 0 ) return 0;

	asm("
		mov $21, %%al
		mov $0x13, %%ah
		mov %1 ,%%edi
		int $0x20
		mov %%ax, %0
		"
		: "=m" (buf)
		: "m" (Mouse_ID)
		: "eax", "edi"
	);
	buf=buf&4; //Mask left button only
	if( buf==Mouse_Buttons ) return 0;
	Mouse_Buttons=buf;
	return 1;
}

int UpdateMousePos()
{
	short buf_x, buf_y;

	if( Mouse_Module == 0 ) return 0;

	asm("
		mov $21, %%al
		mov $0x11, %%ah
		mov %2 ,%%edi
		int $0x20
		mov %%cx, %0
		mov %%dx, %1
		"
		: "=m" (buf_x), "=m" (buf_y)
		: "m" (Mouse_ID)
		: "eax", "ecx", "edx", "ebx", "edi", "esi"
	);

	buf_x=buf_x/8;
	buf_y=buf_y/8;

	if( (buf_x != Mouse_X) | (buf_y != Mouse_Y) )
	{
		Display_Mouse( 1 );
		Mouse_X = buf_x;
		Mouse_Y = buf_y;
		Display_Mouse( 0 );
		return 1;
	} else 
		return 0;
}

void Mouse_Init()
{
	term_puts( SCR_CRASH, "Mouse_Init" );

	Mouse_Module = CheckModuleInstallation( Mouse_ID );

	if( Mouse_Module==0 )
	{
		term_puts( SCR_DEBUG, "No mouse found, mouse disabled!\r\n");
		return;
	}
	else term_puts( SCR_DEBUG, "Mouse found, mouse enabled\r\n");

	term_puts( SCR_CRASH, "Mouse_Init: found mouse!" );

	asm("
			// reset Mouse
		mov $21, %%al
		mov $0x10, %%ah
		mov %0 ,%%edi
		int $0x20

			// Hide mouse
		mov $21, %%al
		mov $0x14, %%ah
		mov %0 ,%%edi
		int $0x20
		"
		:
		: "m" (Mouse_ID)
		: "eax", "edi"
	);

//	UpdateMousePos();
	UpdateMouseButtons();
}
